package entidades;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

public class Cliente {

    private String cpf;
    private String nome;

    public Cliente(String cpf) {
        setCpf(cpf);
        restore(cpf);
    }

    public String getCpf() {
        if (cpf == null) return "";
        return cpf;
        
    }

    public boolean setCpf(String cpf) {
        if (cpf == null) return false;
        cpf = cpf.replaceAll("[.-]","");
        if (cpf.length() != 11) return false;
        this.cpf = cpf;
        return true;
    }

    public String getNome() {
        if (nome == null) return "";
        return nome;
    }

    public boolean setNome(String nome) {
        if (nome == null) return false;  
        if (nome.length() < 5) return false;
        this.nome = nome;
        return true;
    }

    @Override
    public String toString() {
        return "Cliente{" + "cpf=" + getCpf() + ", nome=" + getNome() + '}';
    }
    
    public boolean persist() {

       try {
            Class.forName("org.apache.derby.jdbc.ClientDriver");
            Connection con = DriverManager.getConnection(
                    "jdbc:derby://localhost:1527/sisclientes",
                    "sisclientes","sisclientes");
            if (con == null) throw new SQLException();
            Statement trans = con.createStatement();

            String query = "INSERT INTO app.cliente VALUES(";
            query += "'" + getCpf() + "'";
            query += ", ";
            query += "'" + getNome() + "'";
            query += ")";
            
            int linhas = trans.executeUpdate(query);
            
            if (linhas == 0) {
                query = "UPDATE app.cliente SET ";
                query += "nome = '" + getNome() + "'";
                query += " WHERE ";
                query += "cpf = '" + getCpf() + "'";
                
                linhas = trans.executeUpdate(query);
            }
 
            trans.close();
            con.close();
            
            if (linhas != 0) return true;
            
        } catch (ClassNotFoundException ex) {
            System.err.println(ex);  
        } catch (SQLException ex) {
            System.err.println(ex);
        } finally {            
        }
         
        return false;
    }

    
    public boolean restore(String cpf) {

       try {
            Class.forName("org.apache.derby.jdbc.ClientDriver");
            Connection con = DriverManager.getConnection(
                    "jdbc:derby://localhost:1527/sisclientes",
                    "sisclientes","sisclientes");
            if (con == null) throw new SQLException();
            Statement trans = con.createStatement();

            String query = "SELECT * FROM app.cliente";
            query += " WHERE ";
            query += "cpf = '" + cpf + "'";
                
            ResultSet res = trans.executeQuery(query);
            
            if (res.next()) {
                setNome( res.getString("nome") );
                setCpf( res.getString("cpf") );
                trans.close();
                con.close();
                return true;
            } 
            
            trans.close();
            con.close();
            
          
        } catch (ClassNotFoundException ex) {
            System.err.println(ex);  
        } catch (SQLException ex) {
            System.err.println(ex);
        } finally {            
        }
         
        return false;
    }
    
}
